/* DBusServer.c generated by valac 0.36.3, the Vala compiler
 * generated from DBusServer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <appstream.h>


#define TYPE_DBUS_SERVER (dbus_server_get_type ())
#define DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DBUS_SERVER, DBusServer))
#define DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DBUS_SERVER, DBusServerClass))
#define IS_DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DBUS_SERVER))
#define IS_DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DBUS_SERVER))
#define DBUS_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DBUS_SERVER, DBusServerClass))

typedef struct _DBusServer DBusServer;
typedef struct _DBusServerClass DBusServerClass;
typedef struct _DBusServerPrivate DBusServerPrivate;

#define APP_CENTER_CORE_TYPE_CLIENT (app_center_core_client_get_type ())
#define APP_CENTER_CORE_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClient))
#define APP_CENTER_CORE_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClientClass))
#define APP_CENTER_CORE_IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_CLIENT))
#define APP_CENTER_CORE_IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_CLIENT))
#define APP_CENTER_CORE_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_CLIENT, AppCenterCoreClientClass))

typedef struct _AppCenterCoreClient AppCenterCoreClient;
typedef struct _AppCenterCoreClientClass AppCenterCoreClientClass;

#define APP_CENTER_CORE_TYPE_PACKAGE (app_center_core_package_get_type ())
#define APP_CENTER_CORE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackage))
#define APP_CENTER_CORE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackageClass))
#define APP_CENTER_CORE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_PACKAGE))
#define APP_CENTER_CORE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_PACKAGE))
#define APP_CENTER_CORE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackageClass))

typedef struct _AppCenterCorePackage AppCenterCorePackage;
typedef struct _AppCenterCorePackageClass AppCenterCorePackageClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DBusServer {
	GObject parent_instance;
	DBusServerPrivate * priv;
};

struct _DBusServerClass {
	GObjectClass parent_class;
};


static gpointer dbus_server_parent_class = NULL;
static GOnce dbus_server_instance;
static GOnce dbus_server_instance = G_ONCE_INIT;

GType dbus_server_get_type (void) G_GNUC_CONST;
guint dbus_server_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
enum  {
	DBUS_SERVER_DUMMY_PROPERTY
};
DBusServer* dbus_server_get_default (void);
static DBusServer* __lambda121_ (void);
static DBusServer* dbus_server_new (void);
static DBusServer* dbus_server_construct (GType object_type);
static gpointer ___lambda121__gthread_func (gpointer self);
void dbus_server_init (void);
GType app_center_core_client_get_type (void) G_GNUC_CONST;
AppCenterCoreClient* app_center_core_client_get_default (void);
GType app_center_core_package_get_type (void) G_GNUC_CONST;
GeeCollection* app_center_core_client_get_installed_applications_sync (AppCenterCoreClient* self);
void dbus_server_install (DBusServer* self, const gchar* component_id, GError** error);
AppCenterCorePackage* app_center_core_client_get_package_for_component_id (AppCenterCoreClient* self, const gchar* id);
void app_center_core_package_install (AppCenterCorePackage* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean app_center_core_package_install_finish (AppCenterCorePackage* self, GAsyncResult* _res_);
void dbus_server_uninstall (DBusServer* self, const gchar* component_id, GError** error);
void app_center_core_package_uninstall (AppCenterCorePackage* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean app_center_core_package_uninstall_finish (AppCenterCorePackage* self, GAsyncResult* _res_);
void dbus_server_update (DBusServer* self, const gchar* component_id, GError** error);
void app_center_core_package_update (AppCenterCorePackage* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean app_center_core_package_update_finish (AppCenterCorePackage* self, GAsyncResult* _res_);
gchar* dbus_server_get_component_from_desktop_id (DBusServer* self, const gchar* desktop_id);
AppCenterCorePackage* app_center_core_client_get_package_for_desktop_id (AppCenterCoreClient* self, const gchar* desktop_id);
AsComponent* app_center_core_package_get_component (AppCenterCorePackage* self);
gchar** dbus_server_search_components (DBusServer* self, const gchar* query, int* result_length1);
GeeCollection* app_center_core_client_search_applications (AppCenterCoreClient* self, const gchar* query, AsCategory* category);
static void _vala_array_add14 (gchar** * array, int* length, int* size, gchar* value);
static void dbus_server_finalize (GObject * obj);
static void _dbus_dbus_server_install (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_dbus_server_uninstall (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_dbus_server_update (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_dbus_server_get_component_from_desktop_id (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_dbus_server_search_components (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void dbus_server_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* dbus_server_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean dbus_server_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_server_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo _dbus_server_dbus_arg_info_install_component_id = {-1, "component_id", "s"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_install_in[] = {&_dbus_server_dbus_arg_info_install_component_id, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_install_out[] = {NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_install = {-1, "Install", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_install_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_install_out)};
static const GDBusArgInfo _dbus_server_dbus_arg_info_uninstall_component_id = {-1, "component_id", "s"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_uninstall_in[] = {&_dbus_server_dbus_arg_info_uninstall_component_id, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_uninstall_out[] = {NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_uninstall = {-1, "Uninstall", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_uninstall_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_uninstall_out)};
static const GDBusArgInfo _dbus_server_dbus_arg_info_update_component_id = {-1, "component_id", "s"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_update_in[] = {&_dbus_server_dbus_arg_info_update_component_id, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_update_out[] = {NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_update = {-1, "Update", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_update_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_update_out)};
static const GDBusArgInfo _dbus_server_dbus_arg_info_get_component_from_desktop_id_desktop_id = {-1, "desktop_id", "s"};
static const GDBusArgInfo _dbus_server_dbus_arg_info_get_component_from_desktop_id_result = {-1, "result", "s"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_get_component_from_desktop_id_in[] = {&_dbus_server_dbus_arg_info_get_component_from_desktop_id_desktop_id, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_get_component_from_desktop_id_out[] = {&_dbus_server_dbus_arg_info_get_component_from_desktop_id_result, NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_get_component_from_desktop_id = {-1, "GetComponentFromDesktopId", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_get_component_from_desktop_id_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_get_component_from_desktop_id_out)};
static const GDBusArgInfo _dbus_server_dbus_arg_info_search_components_query = {-1, "query", "s"};
static const GDBusArgInfo _dbus_server_dbus_arg_info_search_components_result = {-1, "result", "as"};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_search_components_in[] = {&_dbus_server_dbus_arg_info_search_components_query, NULL};
static const GDBusArgInfo * const _dbus_server_dbus_arg_info_search_components_out[] = {&_dbus_server_dbus_arg_info_search_components_result, NULL};
static const GDBusMethodInfo _dbus_server_dbus_method_info_search_components = {-1, "SearchComponents", (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_search_components_in), (GDBusArgInfo **) (&_dbus_server_dbus_arg_info_search_components_out)};
static const GDBusMethodInfo * const _dbus_server_dbus_method_info[] = {&_dbus_server_dbus_method_info_install, &_dbus_server_dbus_method_info_uninstall, &_dbus_server_dbus_method_info_update, &_dbus_server_dbus_method_info_get_component_from_desktop_id, &_dbus_server_dbus_method_info_search_components, NULL};
static const GDBusSignalInfo * const _dbus_server_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _dbus_server_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _dbus_server_dbus_interface_info = {-1, "io.elementary.appcenter", (GDBusMethodInfo **) (&_dbus_server_dbus_method_info), (GDBusSignalInfo **) (&_dbus_server_dbus_signal_info), (GDBusPropertyInfo **) (&_dbus_server_dbus_property_info)};
static const GDBusInterfaceVTable _dbus_server_dbus_interface_vtable = {dbus_server_dbus_interface_method_call, dbus_server_dbus_interface_get_property, dbus_server_dbus_interface_set_property};

static DBusServer* __lambda121_ (void) {
	DBusServer* result = NULL;
	DBusServer* _tmp0_;
#line 25 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp0_ = dbus_server_new ();
#line 25 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	return result;
#line 162 "DBusServer.c"
}


static gpointer ___lambda121__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda121_ ();
#line 25 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	return result;
#line 171 "DBusServer.c"
}


DBusServer* dbus_server_get_default (void) {
	DBusServer* result = NULL;
	gconstpointer _tmp0_;
#line 25 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp0_ = g_once (&dbus_server_instance, ___lambda121__gthread_func, NULL);
#line 25 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	result = (DBusServer*) _tmp0_;
#line 25 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	return result;
#line 184 "DBusServer.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 29 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	return self ? g_object_ref (self) : NULL;
#line 191 "DBusServer.c"
}


void dbus_server_init (void) {
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_;
	AppCenterCoreClient* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
#line 29 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 29 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 29 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 30 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp2_ = app_center_core_client_get_installed_applications_sync (client);
#line 30 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp3_ = _tmp2_;
#line 30 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (_tmp3_);
#line 28 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 215 "DBusServer.c"
}


static DBusServer* dbus_server_construct (GType object_type) {
	DBusServer * self = NULL;
#line 33 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	self = (DBusServer*) g_object_new (object_type, NULL);
#line 33 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	return self;
#line 225 "DBusServer.c"
}


static DBusServer* dbus_server_new (void) {
#line 33 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	return dbus_server_construct (TYPE_DBUS_SERVER);
#line 232 "DBusServer.c"
}


/**
     * Installs a package that's id is component_id and also
     * sends a notification when installation finishes or shows
     * a dialog when installation fails
     *
     * @param compontent_id  the component ID to install
     */
void dbus_server_install (DBusServer* self, const gchar* component_id, GError** error) {
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_;
	AppCenterCoreClient* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreClient* _tmp2_;
	const gchar* _tmp3_;
	AppCenterCorePackage* _tmp4_;
	AppCenterCorePackage* _tmp5_;
	AppCenterCorePackage* _tmp11_;
	GError * _inner_error_ = NULL;
#line 44 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_if_fail (component_id != NULL);
#line 45 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 45 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 45 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 46 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 46 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp3_ = component_id;
#line 46 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_get_package_for_component_id (_tmp2_, _tmp3_);
#line 46 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	package = _tmp4_;
#line 47 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp5_ = package;
#line 47 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	if (_tmp5_ == NULL) {
#line 276 "DBusServer.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp6_ = component_id;
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp7_ = g_strdup_printf ("Failed to find package for '%s' component ID", _tmp6_);
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp8_ = _tmp7_;
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp8_);
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp10_ = _tmp9_;
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_free0 (_tmp8_);
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_inner_error_ = _tmp10_;
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		g_propagate_error (error, _inner_error_);
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (package);
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (client);
#line 48 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		return;
#line 304 "DBusServer.c"
	}
#line 51 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp11_ = package;
#line 51 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	app_center_core_package_install (_tmp11_, NULL, NULL);
#line 44 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (package);
#line 44 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 314 "DBusServer.c"
}


/**
     * Uninstalls a package that's id is component_id
     *
     * @param compontent_id  the component ID to uninstall
     */
void dbus_server_uninstall (DBusServer* self, const gchar* component_id, GError** error) {
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_;
	AppCenterCoreClient* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreClient* _tmp2_;
	const gchar* _tmp3_;
	AppCenterCorePackage* _tmp4_;
	AppCenterCorePackage* _tmp5_;
	AppCenterCorePackage* _tmp11_;
	GError * _inner_error_ = NULL;
#line 59 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_if_fail (self != NULL);
#line 59 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_if_fail (component_id != NULL);
#line 60 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 60 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 60 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 61 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 61 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp3_ = component_id;
#line 61 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_get_package_for_component_id (_tmp2_, _tmp3_);
#line 61 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	package = _tmp4_;
#line 62 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp5_ = package;
#line 62 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	if (_tmp5_ == NULL) {
#line 356 "DBusServer.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp6_ = component_id;
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp7_ = g_strdup_printf ("Failed to find package for '%s' component ID", _tmp6_);
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp8_ = _tmp7_;
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp8_);
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp10_ = _tmp9_;
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_free0 (_tmp8_);
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_inner_error_ = _tmp10_;
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		g_propagate_error (error, _inner_error_);
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (package);
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (client);
#line 63 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		return;
#line 384 "DBusServer.c"
	}
#line 66 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp11_ = package;
#line 66 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	app_center_core_package_uninstall (_tmp11_, NULL, NULL);
#line 59 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (package);
#line 59 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 394 "DBusServer.c"
}


/**
     * Updates a package that's id is component_id
     *
     * @param compontent_id  the component ID to update
     */
void dbus_server_update (DBusServer* self, const gchar* component_id, GError** error) {
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_;
	AppCenterCoreClient* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreClient* _tmp2_;
	const gchar* _tmp3_;
	AppCenterCorePackage* _tmp4_;
	AppCenterCorePackage* _tmp5_;
	AppCenterCorePackage* _tmp11_;
	GError * _inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_if_fail (self != NULL);
#line 74 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_if_fail (component_id != NULL);
#line 75 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 75 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 75 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 76 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 76 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp3_ = component_id;
#line 76 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_get_package_for_component_id (_tmp2_, _tmp3_);
#line 76 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	package = _tmp4_;
#line 77 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp5_ = package;
#line 77 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	if (_tmp5_ == NULL) {
#line 436 "DBusServer.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp6_ = component_id;
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp7_ = g_strdup_printf ("Failed to find package for '%s' component ID", _tmp6_);
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp8_ = _tmp7_;
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp8_);
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp10_ = _tmp9_;
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_free0 (_tmp8_);
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_inner_error_ = _tmp10_;
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		g_propagate_error (error, _inner_error_);
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (package);
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (client);
#line 78 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		return;
#line 464 "DBusServer.c"
	}
#line 81 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp11_ = package;
#line 81 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	app_center_core_package_update (_tmp11_, NULL, NULL);
#line 74 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (package);
#line 74 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 474 "DBusServer.c"
}


/**
     * Gets the component ID for the specified desktop ID
     *
     * @param desktop_id  the desktop ID (must include ".desktop" extension)
     * @return the component ID, if not found returns empty string
     */
gchar* dbus_server_get_component_from_desktop_id (DBusServer* self, const gchar* desktop_id) {
	gchar* result = NULL;
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_;
	AppCenterCoreClient* _tmp1_;
	AppCenterCorePackage* package = NULL;
	AppCenterCoreClient* _tmp2_;
	const gchar* _tmp3_;
	AppCenterCorePackage* _tmp4_;
	AppCenterCorePackage* _tmp5_;
	gchar* _tmp11_;
#line 90 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_val_if_fail (desktop_id != NULL, NULL);
#line 91 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 91 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 91 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 92 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 92 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp3_ = desktop_id;
#line 92 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_get_package_for_desktop_id (_tmp2_, _tmp3_);
#line 92 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	package = _tmp4_;
#line 93 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp5_ = package;
#line 93 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	if (_tmp5_ != NULL) {
#line 517 "DBusServer.c"
		AppCenterCorePackage* _tmp6_;
		AsComponent* _tmp7_;
		AsComponent* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp6_ = package;
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp7_ = app_center_core_package_get_component (_tmp6_);
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp8_ = _tmp7_;
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp9_ = as_component_get_id (_tmp8_);
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		result = _tmp10_;
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (package);
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (client);
#line 94 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		return result;
#line 541 "DBusServer.c"
	}
#line 97 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp11_ = g_strdup ("");
#line 97 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	result = _tmp11_;
#line 97 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (package);
#line 97 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 97 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	return result;
#line 553 "DBusServer.c"
}


/**
     * Searches for a query in the AppStream database
     *
     * @param query  the query to search for
     * @return a list of component ID's that match the query
     */
static void _vala_array_add14 (gchar** * array, int* length, int* size, gchar* value) {
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	if ((*length) == (*size)) {
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 570 "DBusServer.c"
	}
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	(*array)[(*length)++] = value;
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	(*array)[*length] = NULL;
#line 576 "DBusServer.c"
}


gchar** dbus_server_search_components (DBusServer* self, const gchar* query, int* result_length1) {
	gchar** result = NULL;
	AppCenterCoreClient* client = NULL;
	AppCenterCoreClient* _tmp0_;
	AppCenterCoreClient* _tmp1_;
	GeeCollection* packages = NULL;
	AppCenterCoreClient* _tmp2_;
	const gchar* _tmp3_;
	GeeCollection* _tmp4_;
	gchar** components = NULL;
	gchar** _tmp5_;
	gint components_length1;
	gint _components_size_;
	gchar** _tmp18_;
	gint _tmp18__length1;
#line 106 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 107 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp0_ = app_center_core_client_get_default ();
#line 107 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 107 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	client = _tmp1_;
#line 108 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp2_ = client;
#line 108 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp3_ = query;
#line 108 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp4_ = app_center_core_client_search_applications (_tmp2_, _tmp3_, NULL);
#line 108 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	packages = _tmp4_;
#line 109 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp5_ = g_new0 (gchar*, 0 + 1);
#line 109 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	components = _tmp5_;
#line 109 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	components_length1 = 0;
#line 109 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_components_size_ = components_length1;
#line 621 "DBusServer.c"
	{
		GeeIterator* _package_it = NULL;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp6_ = packages;
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_package_it = _tmp7_;
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		while (TRUE) {
#line 634 "DBusServer.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_;
			AppCenterCorePackage* package = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			gchar** _tmp12_;
			gint _tmp12__length1;
			AppCenterCorePackage* _tmp13_;
			AsComponent* _tmp14_;
			AsComponent* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp8_ = _package_it;
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			if (!_tmp9_) {
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
				break;
#line 655 "DBusServer.c"
			}
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp10_ = _package_it;
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			package = (AppCenterCorePackage*) _tmp11_;
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp12_ = components;
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp12__length1 = components_length1;
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp13_ = package;
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp14_ = app_center_core_package_get_component (_tmp13_);
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp15_ = _tmp14_;
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp16_ = as_component_get_id (_tmp15_);
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 111 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_vala_array_add14 (&components, &components_length1, &_components_size_, _tmp17_);
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
			_g_object_unref0 (package);
#line 681 "DBusServer.c"
		}
#line 110 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		_g_object_unref0 (_package_it);
#line 685 "DBusServer.c"
	}
#line 114 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp18_ = components;
#line 114 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_tmp18__length1 = components_length1;
#line 114 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	if (result_length1) {
#line 114 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
		*result_length1 = _tmp18__length1;
#line 695 "DBusServer.c"
	}
#line 114 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	result = _tmp18_;
#line 114 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (packages);
#line 114 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	_g_object_unref0 (client);
#line 114 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	return result;
#line 705 "DBusServer.c"
}


static void dbus_server_class_init (DBusServerClass * klass) {
#line 22 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	dbus_server_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	G_OBJECT_CLASS (klass)->finalize = dbus_server_finalize;
#line 714 "DBusServer.c"
}


static void dbus_server_instance_init (DBusServer * self) {
}


static void dbus_server_finalize (GObject * obj) {
	DBusServer * self;
#line 22 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DBUS_SERVER, DBusServer);
#line 22 "/builddir/build/BUILD/appcenter-0.2.4/src/Services/DBusServer.vala"
	G_OBJECT_CLASS (dbus_server_parent_class)->finalize (obj);
#line 728 "DBusServer.c"
}


GType dbus_server_get_type (void) {
	static volatile gsize dbus_server_type_id__volatile = 0;
	if (g_once_init_enter (&dbus_server_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DBusServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dbus_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DBusServer), 0, (GInstanceInitFunc) dbus_server_instance_init, NULL };
		GType dbus_server_type_id;
		dbus_server_type_id = g_type_register_static (G_TYPE_OBJECT, "DBusServer", &g_define_type_info, 0);
		g_type_set_qdata (dbus_server_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) dbus_server_register_object);
		g_once_init_leave (&dbus_server_type_id__volatile, dbus_server_type_id);
	}
	return dbus_server_type_id__volatile;
}


static void _dbus_dbus_server_install (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* component_id = NULL;
	GVariant* _tmp9_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp9_ = g_variant_iter_next_value (&_arguments_iter);
	component_id = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	dbus_server_install (self, component_id, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (component_id);
}


static void _dbus_dbus_server_uninstall (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* component_id = NULL;
	GVariant* _tmp10_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp10_ = g_variant_iter_next_value (&_arguments_iter);
	component_id = g_variant_dup_string (_tmp10_, NULL);
	g_variant_unref (_tmp10_);
	dbus_server_uninstall (self, component_id, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (component_id);
}


static void _dbus_dbus_server_update (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* component_id = NULL;
	GVariant* _tmp11_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	component_id = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	dbus_server_update (self, component_id, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (component_id);
}


static void _dbus_dbus_server_get_component_from_desktop_id (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* desktop_id = NULL;
	GVariant* _tmp12_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	desktop_id = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	result = dbus_server_get_component_from_desktop_id (self, desktop_id);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (desktop_id);
}


static void _dbus_dbus_server_search_components (DBusServer* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* query = NULL;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	int result_length1 = 0;
	gchar** _tmp14_;
	GVariantBuilder _tmp15_;
	int _tmp16_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	query = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	result = dbus_server_search_components (self, query, &result_length1);
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp14_ = result;
	g_variant_builder_init (&_tmp15_, G_VARIANT_TYPE ("as"));
	for (_tmp16_ = 0; _tmp16_ < result_length1; _tmp16_++) {
		g_variant_builder_add_value (&_tmp15_, g_variant_new_string (*_tmp14_));
		_tmp14_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp15_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (query);
}


static void dbus_server_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Install") == 0) {
		_dbus_dbus_server_install (object, parameters, invocation);
	} else if (strcmp (method_name, "Uninstall") == 0) {
		_dbus_dbus_server_uninstall (object, parameters, invocation);
	} else if (strcmp (method_name, "Update") == 0) {
		_dbus_dbus_server_update (object, parameters, invocation);
	} else if (strcmp (method_name, "GetComponentFromDesktopId") == 0) {
		_dbus_dbus_server_get_component_from_desktop_id (object, parameters, invocation);
	} else if (strcmp (method_name, "SearchComponents") == 0) {
		_dbus_dbus_server_search_components (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* dbus_server_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean dbus_server_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint dbus_server_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_dbus_server_dbus_interface_info), &_dbus_server_dbus_interface_vtable, data, _dbus_server_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _dbus_server_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



